! Jacobi 9-point stencil operation
! add the data region to J2
! 
subroutine jacobi( a, newa, n, m, w0, w1, w2, tolerance, change, iters )
 real :: w0, w1, w2, tolerance
 integer :: n, m
 real, dimension(:,:) :: a, newa
 real, intent(out) :: change
 integer, intent(out) :: iters

 integer :: i,j

 change = tolerance + 1	! get into the while loop

 iters = 0
!$acc data create(newa) copy(a(:,:))
 do while ( change > tolerance)
  iters = iters + 1
  change = 0
!$acc parallel
    do j = 2, n-1
      do i = 2, m-1
        newa(i,j) = w0 * a(i,j) + &
 		w1 * (a(i-1,j) + a(i,j-1) + a(i+1,j) + a(i,j+1) ) + &
 		w2 * (a(i-1,j-1) + a(i-1,j+1) + a(i+1,j-1) + a(i+1,j+1) )
        change = max( change, abs( newa(i,j) - a(i,j) ) )
      enddo
    enddo
    a(2:m-1,2:n-1) = newa(2:m-1,2:n-1)
!$acc end parallel 
enddo
!$acc end data
end subroutine
