! main routine to call any of the accelerator model Jacobi routines
!
program main
 interface
  subroutine jacobi( a, newa, n, m, w0, w1, w2, tolerance, change, iters )
   real :: w0, w1, w2, tolerance
   integer :: n, m
   real, dimension(:,:) :: a, newa
   real, intent(out) :: change
   integer, intent(out) :: iters
  end subroutine
 end interface

 integer nargs
 integer n, m
 character*10 arg
 real, allocatable :: a(:,:), newa(:,:)
 real :: delta
 integer :: iters

 integer :: dt1(8), dt2(8), t1, t2
 real :: rt

 n = 400
 nargs = iargc()
 if( nargs == 0 )then
   print *, 'jacobi size1 [size2, defaults to size1]'
   return
 endif
 if( nargs >= 1 )then
  call getarg( 1, arg )
  read(arg,'(i)') n
 endif

 m = n
 if( nargs >= 2 )then
  call getarg( 2, arg )
  read(arg,'(i)') m
 endif

 allocate( a(m,n) )
 allocate( newa(m,n) )

 do j = 1,n
  do i = 1,m
   a(i,j) = 0
   newa(i,j) = 0
  enddo
 enddo
 do i = 1, m
  a(i,n) = i
 enddo
 do j = 1, n
  a(m,j) = j
 enddo
 a(m,n) = m+n

 call date_and_time( values=dt1 )
 call jacobi( a, newa, n, m, .2, .1, .1, .1, delta, iters )
 call date_and_time( values=dt2 )
 t1 = dt1(8) + 1000*(dt1(7)+60*dt1(6)+60*(dt1(5)))
 t2 = dt2(8) + 1000*(dt2(7)+60*dt2(6)+60*(dt2(5)))
 write(*,10) delta, iters, n, m
10 format( 'reached delta=', f15.6, ' in ', i, ' iterations for ', i4, ' x ', i4, ' array' )
 rt = (t2 - t1)
 rt = rt / 1000.
 write(*,20) rt
20 format( 'time=', f15.6, ' seconds' )

end program
