! Accelerator model Fortran for vector add
! compare to CUDA Fortran version for complexity, performance
! This example is originally from PGI traning session
! and is modified for apc traning session
! by BSD_Conqueror
module vadd_mod
contains
    subroutine vadd( A, B, C )
	implicit none
	real(4), dimension(:) :: A, B, C
	integer :: N, I
	N = size( A, 1 )
! this loop is parallelizable
! todo: add the proper pgi accelerator directive to offload the loop to GPU
!$acc parallel 
	do i = 1, N
	    C(i) = A(i) + B(i)
	enddo
!$acc end parallel
    end subroutine
end module

program p
    use vadd_mod
    use accel_lib
    implicit none
    integer :: nargs, n, i, ierr
    real, allocatable, dimension(:) :: a, b, c
    integer :: dt1(8), dt2(8), t1, t2
    external iargc
    integer iargc
    real :: rt
    character*10 arg

    nargs = iargc()
    if( nargs == 0 )then
	print *, 'a.out size1'
	return
    endif
    if( nargs >= 1 )then
	call getarg( 1, arg )
	read(arg,'(i)') n
    endif

    allocate( a(n), b(n), c(n) )
    do i = 1,n 
	a(i) = i
	b(i) = 2*i
	c(i) = 0
    enddo
    call acc_init(acc_device_nvidia)
    call date_and_time( values=dt1 )
    call vadd( a, b, c )
    call date_and_time( values=dt2 )
    t1 = dt1(8) + 1000*(dt1(7)+60*dt1(6)+60*(dt1(5)))
    t2 = dt2(8) + 1000*(dt2(7)+60*dt2(6)+60*(dt2(5)))
    rt = (t2 - t1)
    rt = rt / 1000.
    write(*,20) rt
    20 format( 'time=', f7.4, ' seconds' )

    ierr = 0
    do i = 1,n
	if( c(i) .ne. a(i) + b(i) )then
	    ierr = ierr + 1
	    if( ierr <= 10 )then
		print 30, i, c(i), a(i)+b(I)
		30 format( 'c(',i,') = ', f12.5, ' should be ', f12.5 )
	    endif
	endif
    enddo
end program


integer function ival( arg )
    character*(*) :: arg
    character*1 :: ch
    integer i
    ival = 0
    do i = 1, len(arg)
	ch = arg(i:i)
	if( ch .ge. '0' .and. ch .le. '9' )then
	    ival = ival * 10 + ichar(ch) - ichar('0')
	endif
    enddo
end function
